<template>
  <div class="category-add">
    <h2 class="dialog_add-title">添加模板</h2>
    <dialog-input
      class="dialog_add-form dialog_add-input_name"
      v-model.trim="name"
      :errorShowing="isErrorShowing"
      placeholder="请输入模板名称"
    />
    <el-select v-model="value" placeholder="请选择">
      <el-option v-for="item in MyCategories" :key="item.value" :label="item.name" :value="item.id"></el-option>
    </el-select>
    <button class="dialog_add-btn_confirm" @click="checkForm">确定</button>
    <button class="dialog_add-btn_cancel" @click="closeDialog">取消</button>
  </div>
</template>

<script>
import DialogInput from "@/components/DialogInput.vue";
import { GO_URLS } from "@/config/URLS";
export default {
  data() {
    return {
      name: "",
      isErrorShowing: false, // 错误提示
      isInActive: false,
      MyCategories: [],
      value: "",
    };
  },
  components: { DialogInput },
  created() {
    this.getFolderList();
  },
  methods: {
    async checkForm() {
      if (this.isInActive) return;
      this.isInActive = true;
      this.isErrorShowing = true;
      // 追加非空验证
      if (this.name === "") {
        this.$message("模板名称不可为空");
        this.isInActive = false;
        return null;
      }
      if (this.value === "") {
        // this.$message("请选择分类");
        // this.isInActive = false;
        this.value = this.MyCategories[0].id;
        // return null;
      }
      const data = await this.$ajax({
        type: "post",
        url: GO_URLS.customize,
        params: {
          detail: "",
          folder_id: this.value,
          name: this.name,
          info: this.name,
        },
      });
      if (data) {
        this.$emit("successCallback", this.value);
      }
      this.isInActive = false;
    },
    closeDialog() {
      this.$emit("close");
    },
    // 获取我的模板列表
    async getFolderList() {
      const res = await this.$ajax({
        type: "post",
        url: GO_URLS.folderList,
        params: {
          page: 1,
          page_size: 100,
          template_type: 1,
        },
      });
      if (res) {
        this.MyCategories = res.data.results;
      }
    },
  },
};
</script>

<style lang="less" scoped>
.category-add {
  width: 589px;
  height: 350px;
  background: rgba(255, 255, 255, 1);
  box-shadow: 0px 0px 20px 0px rgba(61, 118, 249, 0.18);
}

.dialog_add-title {
  margin: 0;
  color: #000;
  font-size: 22px;
  line-height: 30px;
  padding-left: 44px;
  padding-top: 45px;
}

.dialog_add-input_name {
  margin-left: 50px;
  margin-top: 39px;
  margin-bottom: 18px;
}

.dialog_add-btn_confirm {
  float: right;
  width: 120px;
  height: 40px;
  color: #fff;
  font-size: 14px;
  outline: none;
  background: #3f79fe;
  border-radius: 4px;
  border: none;
  cursor: pointer;
  margin-right: 39px;
}

.dialog_add-btn_cancel {
  float: right;
  margin-right: 18px; /* 28 - 10 */
  border: none;
  width: 48px; /* 28 + 增大20 */
  height: 40px;
  outline: none;
  background: #fff;
  color: #5c6476;
  font-size: 14px;
  cursor: pointer;
}
.el-select {
  width: 500px;
  margin-left: 50px;
  margin-bottom: 40px;
}
/deep/.el-input__inner {
  height: 44px;
  padding: 0 26px;
}
</style>